/*****************************************************************************

GRAOUMF TRACKER 2

Copyright (c) 1996 - 2002 Laurent de Soras

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact the author : laurent@ohmforce.com
More information about this license : http://www.gnu.org/licenses/gpl.html

*****************************************************************************/



#if defined (PLAY_CT_CURRENT_HEADER)
	#error Inclusion recursive du header PLAY_CT.
#endif
#define	PLAY_CT_CURRENT_HEADER

#if ! defined (PLAY_CT_HEADER_INCLUDED)
#define	PLAY_CT_HEADER_INCLUDED



/*\\\ INCLUDES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include "archi.h"



/*\\\ CONSTANTES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ TYPES & STRUCTURES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/* Element du tableau de la configuration des sources d'un effet */
typedef struct
{
	BYTE	track_type;			/* Type de la voie: SPL, FX ou AIN */
	bool	wet_flag;			/* Pour les pistes d'effets, 0 = dry, 1 = wet */
	WORD	track_nbr;			/* Numero de la voie */
	UWORD	inpvol;				/* Volume d'entree 0...1000...FFFF */
	UWORD	inppan;				/* Balance d'entree 0...8000...FFFF */
	struct
	{
		SLWORD	old_vol [2];	// Volume du tick precedent [wet/dry] [chn]
		SLWORD	new_vol [2];	// Volume du tick courant [wet/dry] [chn]
	}		cr;					// Partie destinee au click removal
} PLAY_SOURCE_TRACK_CONF_BLOCK;



/*\\\ FIN DU FICHIER \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#endif

#undef PLAY_CT_CURRENT_HEADER
